<template>
  <div class="form mt-2">
    <div class="saved-beneficiary mt-3">
      <p class="fw-bold">Saved Beneficiary</p>
      <div class="w-25" style="margin-left: auto">
        <vs-input
          v-model="searchBeneficiary"
          border
          placeholder="Search Beneficiary"
        />
      </div>

      <div class="mt-2">
        <div class="d-flex flex-wrap justify-content-between">
          <div class="text-center" @click="createBeneficiaryModal = true">
            <vs-avatar class="m-auto" circle size="60">
              <template #text> + </template>
            </vs-avatar>
            <p class="mt-1 fw-bold text-sm">Add New</p>
          </div>

          <div
            v-for="(beneficiary, i) in resultQuery"
            :key="i"
            class="text-center"
            @click="updateBeneficiaryDetails(beneficiary)"
          >
            <vs-avatar class="m-auto" circle size="60">
              <img :src="beneficiary.image" alt="" />
            </vs-avatar>
            <p class="mt-1 fw-bold text-sm text-capitalize">
              {{ beneficiary.name }}
            </p>
          </div>
        </div>
      </div>
    </div>
    <form @submit.prevent="submitForm">
      <div class="row">
        <div class="col-sm-12 col-md-6">
          <div class="form-group">
            <label class="mb-2">Account to Debit:</label>
            <select
              v-model="form.accountFrom"
              v-validate="'required'"
              class="form-select"
              name="Account to Debit"
            >
              <option
                v-for="(account, i) in accounts"
                :key="i"
                :value="account"
              >
                {{ `${account.AccountType} - ${account.AccountNumber}` }}
              </option>
            </select>
            <div
              v-show="verrors.has('Account to Debit')"
              class="invalid-feedback"
            >
              {{ verrors.first('Account to Debit') }}
            </div>
          </div>
          <div class="form-group mt-2">
            <label class="mb-2">Beneficiary Account:</label>
            <input
              v-model="form.beneficiaryAccount"
              v-validate="'required|integer'"
              type="text"
              class="form-control"
              name="Beneficiary Account"
              @input="fetchBeneficiaryName()"
            />
            <div
              v-show="verrors.has('Beneficiary Account')"
              class="invalid-feedback"
            >
              {{ verrors.first('Beneficiary Account') }}
            </div>
          </div>
          <div class="form-group mt-2">
            <label class="mb-2">Beneficiary Name:</label>
            <input
              v-model="form.beneficiaryName"
              v-validate="'required'"
              type="text"
              class="form-control fw-bold"
              name="Beneficiary Name"
              disabled
            />
            <div
              v-show="verrors.has('Beneficiary Name')"
              class="invalid-feedback"
            >
              {{ verrors.first('Beneficiary Name') }}
            </div>
          </div>
          <div class="form-group mt-3">
            <label class="mb-2">Amount</label>
            <div class="input-group">
              <span
                class="input-group-text border-0 text-dark fw-bold"
                style="background: #f4f2ec"
                >N</span
              >
              <currency-input
                v-model="form.amount"
                v-validate="'required|decimal'"
                currency="NGN"
                class="form-control"
                type="text"
                name="Amount"
              />
            </div>
            <div v-show="verrors.has('Amount')" class="invalid-feedback">
              {{ verrors.first('Amount') }}
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-6">
          <div class="form-group">
            <label class="mb-2">Note (optional)</label>
            <textarea
              v-model="form.note"
              rows="5"
              class="form-control"
            ></textarea>
          </div>
          <div class="form-group">
            <label class="mb-2">Transaction PIN</label>

            <input
              v-model="form.pin"
              v-validate="'required'"
              type="password"
              class="form-control"
              name="Transaction PIN"
            />
            <div
              v-show="verrors.has('Transaction PIN')"
              class="invalid-feedback"
            >
              {{ verrors.first('Transaction PIN') }}
            </div>
          </div>
          <div class="mt-3">
            <div class="d-flex justify-content-between">
              <!-- <button
                class="btn btn-light btn-lg rounded-1 px-4"
                style="font-size: 14px"
              >
                Cancel
              </button> -->
              <!-- <button
                class="btn btn-primary btn-lg rounded-1 px-4 h6"
                type="button"
                style="font-size: 14px"
                data-bs-toggle="modal"
                data-bs-target="#TransferSuccessCreationModal"
              >

              </button> -->
              <vs-button :loading="form.active" type="submit" class="px-5">
                Transfer
              </vs-button>
            </div>
          </div>
        </div>
        <div class="col-sm-12 col-md-6"></div>
      </div>
    </form>

    <!-- Modals -->
    <!-- Successful Transfer Modal -->
    <!-- <div
      id="TransferSuccessCreationModal2"
      class="modal fade"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
          </div>
        </div>
      </div>
    </div> -->

    <!-- Create Corestep Account Beneficiary -->

    <vs-dialog v-model="createBeneficiaryModal" width="300px" not-center blur>
      <template #header>
        <h4 class="my-3">Create CoreStep Beneficiary</h4>
      </template>
      <form @submit.prevent="createBeneficiary(createBeneficiaryForm)">
        <div class="create-core-bank-modal">
          <div class="form-group my-4">
            <vs-input
              v-model="createBeneficiaryForm.accountNumber"
              v-validate="'required|integer'"
              label-placeholder="Account Number"
              class="w-100"
              name="Account Number"
              @input="fetchBeneficiary()"
            />
            <div
              v-show="verrors.has('Account Number')"
              class="invalid-feedback"
            >
              {{ verrors.first('Account Number') }}
            </div>
          </div>
          <div class="form-group my-4">
            <vs-input
              v-model="createBeneficiaryForm.accountName"
              v-validate="'required'"
              label-placeholder="Name"
              class="w-100"
              disabled
              name="Name"
            />
            <div v-show="verrors.has('Name')" class="invalid-feedback">
              {{ verrors.first('Name') }}
            </div>
          </div>
          <div class="d-flex my-4 w-100 justify-content-between">
            <vs-button dark transparent @click="createBeneficiaryModal = false">
              Cancel
            </vs-button>
            <vs-button
              type="submit"
              transparent
              :loading="createBeneficiaryForm.active"
              :disabled="
                createBeneficiaryForm.active || !beneficiaryAccountVerified
              "
            >
              Save
            </vs-button>
          </div>
        </div>
      </form>
      <template #footer> </template>
    </vs-dialog>

    <!-- Download Reciept -->
    <vs-dialog
      v-model="downloadRecieptModal"
      width="300px"
      not-center
      blur
      @close="redirect()"
    >
      <template #header>
        <h4 class="my-3">Do you want to save Beneficiary</h4>
      </template>

      <div class="text-center">
        <img
          src="@/assets/images/transfer-success-icon.png"
          alt="Transfer Successfull"
        />
      </div>
      <div class="px-5 text-center mt-3">
        <h3 class="fw-bold text-dark my-2">Transfer Successful!</h3>
        <p class="text-muted my-2 px-3">
          Congratulations, your transfer was completed successfully!
        </p>

        <div class="mt-3">
          <div class="row">
            <div class="col-sm-12 col-md-12">
              <div
                class="bg-light p-3 text-left"
                style="text-align: left !important"
              >
                <h5 class="fw-bold">{{ form.amount | formatPrice }}</h5>
                <p class="text-muted m-0" style="font-size: 10px">
                  * Note that the transfer might take a few minutes to reflect
                </p>
              </div>
            </div>
          </div>
        </div>

        <div class="mt-3">
          <div class="d-flex justify-content-between">
            <vs-button
              square
              warn
              gradient
              size="large"
              class="w-100"
              @click="redirectToANewTab(recieptLink)"
            >
              Download Receipts
            </vs-button>
            <vs-button
              square
              icon
              color="rgb(59,222,200)"
              gradient
              size="large"
              class="w-100 mt-2"
              @click="shareViaEmail()"
            >
              Share Via Mail
            </vs-button>
          </div>
        </div>
        <div class="mt-3">
          <!-- <p class="text-primary fw-bold">Save Recipient as Beneficiary</p> -->
        </div>
      </div>
    </vs-dialog>

    <!-- Transaction Summary Modal -->
    <vs-dialog v-model="transactionSummaryModal" width="300px" not-center blur>
      <template #header>
        <h4 class="my-3">Transaction Summary</h4>
      </template>
      <vs-table class="my-2">
        <template #tbody>
          <vs-tr>
            <vs-td class="fw-bold"> Account to Debit: </vs-td>
            <vs-td> {{ transactionSummary.accountToDebit }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Beneficiary Account: </vs-td>
            <vs-td> {{ transactionSummary.beneficiaryAccount }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Beneficiary Name: </vs-td>
            <vs-td> {{ transactionSummary.beneficiaryName }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Amount</vs-td>
            <vs-td> {{ transactionSummary.amount | formatPrice }} </vs-td>
          </vs-tr>
          <vs-tr>
            <vs-td class="fw-bold"> Note</vs-td>
            <vs-td> {{ transactionSummary.note }} </vs-td>
          </vs-tr>
        </template>
      </vs-table>
      <vs-alert class="mt-3">
        <template #title> ARE YOU SURE YOU WANT TO PAY </template>
      </vs-alert>
      <div class="d-flex my-4 w-100 justify-content-between">
        <vs-button dark transparent @click="transactionSummaryModal = false">
          Cancel
        </vs-button>
        <vs-button
          :loading="form.active"
          class="px-5"
          type="submit"
          primary
          @click="makeTransfer()"
        >
          PAY
        </vs-button>
      </div>
      <template #footer> </template>
    </vs-dialog>
  </div>
</template>

<script>
export default {
  props: {
    accounts: {
      required: true,
      default: [],
    },
  },
  data: () => ({
    searchBeneficiary: '',
    createBeneficiaryModal: false,
    createBeneficiaryForm: {
      input1: '',
      active: false,
      accountNumber: '',
      accountName: '',
    },
    form: {
      active: false,
      accountFrom: {},
      accountTo: null,
      beneficiaryAccount: '',
    },
    beneficiaries: [],
    beneficiaryAccountName: '',
    beneficiaryAccountVerified: false,
    saveBeneficiaryModal: false,
    transactionSummaryModal: false,
    transactionSummary: {},
    downloadRecieptModal: false,
    recieptLink: '',
  }),
  computed: {
    resultQuery() {
      if (this.searchBeneficiary) {
        return this.beneficiaries.filter((user) => {
          return this.searchBeneficiary
            .toLowerCase()
            .split(' ')
            .every((v) => user.name.toLowerCase().includes(v))
        })
      } else {
        return this.beneficiaries
      }
    },
  },
  created() {
    // console.log(this.accounts)
    this.form.accountFrom = this.accounts[0]
    this.fetchBeneficiaries()
  },
  methods: {
    redirectToANewTab(link) {
      window.open(link, '_blank')
    },
    shareViaEmail() {
      window.open(
        `mailto:?subject= I want to share this reciept with you &body= Hi there, Check out this reciept ${this.recieptLink}. Thanks.`,
        '_blank'
      )
    },
    redirect() {
      window.location = '/user/dashboard/transaction-history'
    },
    saveBeneficiary() {
      this.saveBeneficiaryModal = false
      this.createBeneficiaryModal = true
      this.createBeneficiaryForm.accountNumber = this.form.beneficiaryAccount
      this.createBeneficiaryForm.bank = this.form.bank
      this.fetchBeneficiary()
    },
    updateBeneficiaryDetails(beneficiary) {
      // console.log(beneficiary.accountNumber)
      this.form.beneficiaryAccount = beneficiary.accountNumber
      this.fetchBeneficiaryName()
      // this.form.bank =
      //   this.banks.find((bank) => bank.cbnCode === beneficiary.cbnCode) || null
      // this.form.beneficiaryAccount = beneficiary.accountNumber
    },
    fetchBeneficiaries() {
      this.$axios
        .$get('/beneficiary/corebank?page=1&limit=5')
        .then((response) => {
          this.beneficiaries = response.payload.data
          // console.log(response)
        })
    },
    fetchBeneficiaryName() {
      this.form.beneficiaryName = ''
      if (this.form.beneficiaryAccount && this.form.beneficiaryAccount >= 10) {
        const data = {
          accountNumber: this.form.beneficiaryAccount,
        }
        this.form.active = true
        this.$axios
          .$get(`/user/resolve-corestep-account/${data.accountNumber}`)
          .then((response) => {
            console.log(response)
            this.form.active = false
            this.form.beneficiaryName = response.payload.AccountName
          })
          .catch((error) => {
            console.log(error)
            this.form.active = false
            this.form.beneficiaryName = ''
            if (
              error.response.status === 404 ||
              error.response.status === 400 ||
              error.response.status === 401 ||
              error.response.status === 403 ||
              error.response.status === 406
            ) {
              // console.log(error.response.data.message)
              this.openNotification(
                'top-left',
                'danger',
                error.response.data.message
              )
            } else {
              this.openNotification(
                'top-left',
                'danger',
                error.response.data.message
              )
            }
          })
      }
    },
    fetchBeneficiary() {
      this.beneficiaryAccountVerified = false
      this.createBeneficiaryForm.accountName = ''
      if (
        this.createBeneficiaryForm.accountNumber &&
        this.createBeneficiaryForm.accountNumber.length >= 10
      ) {
        const data = {
          accountNumber: this.createBeneficiaryForm.accountNumber,
        }
        this.createBeneficiaryForm.active = true
        this.$axios
          .$get(`/user/resolve-corestep-account/${data.accountNumber}`)
          .then((response) => {
            this.createBeneficiaryForm.active = false
            this.beneficiaryAccountVerified = true
            this.createBeneficiaryForm.accountName =
              response.payload.AccountName
          })
          .catch((error) => {
            this.beneficiaryAccountName = ''
            this.createBeneficiaryForm.active = false
            this.createBeneficiaryForm.accountName = false
            if (
              error.response.status === 404 ||
              error.response.status === 400 ||
              error.response.status === 401 ||
              error.response.status === 403 ||
              error.response.status === 406
            ) {
              // console.log(error.response.data.message)
              this.openNotification(
                'top-left',
                'danger',
                error.response.data.message
              )
            } else {
              this.openNotification(
                'top-left',
                'danger',
                error.response.data.message
              )
            }
          })
      }
    },
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm(scope) {
      this.$validator.validateAll(scope).then((result) => {
        if (result) {
          // console.log(this.form)
          this.transactionSummary = {
            accountToDebit: this.form.accountFrom.AccountNumber,
            beneficiaryAccount: this.form.beneficiaryAccount,
            beneficiaryName: this.form.beneficiaryName,
            amount: String(this.form.amount),
            note: this.form.note,
          }
          this.transactionSummaryModal = true
        }
      })
    },
    makeTransfer(scope) {
      this.$validator.validateAll(scope).then((result) => {
        if (result) {
          // console.log(this.form)
          const data = {
            accountToDebit: this.form.accountFrom.AccountNumber,
            amount: String(this.form.amount),
            transactionPin: this.form.pin,
            beneficiaryAccountNumber: this.form.beneficiaryAccount,
          }
          this.form.active = true
          this.$axios
            .post('/user/corebank-transfer', data)
            .then((response) => {
              this.form.active = false
              // eslint-disable-next-line
              // const modal = new bootstrap.Modal(
              //   document.getElementById('TransferSuccessCreationModal2'),
              //   {}
              // )
              // modal.show()
              // this.saveBeneficiaryModal = true
              this.recieptLink = response.data.payload.receipt
              this.transactionSummaryModal = false
              this.downloadRecieptModal = true
            })
            .catch((error) => {
              console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    createBeneficiary(scope) {
      this.$validator.validateAll(scope).then((result) => {
        if (result) {
          // console.log(this.form)

          const data = {
            accountNumber: this.createBeneficiaryForm.accountNumber,
            name: this.createBeneficiaryForm.accountName,
            type: 'coreBank',
          }
          this.createBeneficiaryForm.active = true
          this.$axios
            .post('/beneficiary/bank', data)
            .then(({ data }) => {
              console.log(data)
              this.createBeneficiaryModal = false
              this.createBeneficiaryForm.active = false
              this.fetchBeneficiaries()
              // eslint-disable-next-line
              this.openNotification('top-left', 'success', data.message)
              this.redirect()
            })
            .catch((error) => {
              // console.log(error)
              this.createBeneficiaryForm.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
  },
}
</script>

<style lang="scss">
.create-core-bank-modal {
  input.vs-input {
    width: 100%;
  }
}

.vs-table table {
  min-width: 100px;
}
</style>
